#include <windows.h>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include "dllclass.h"

using namespace std;

DllClass* 
new_dllclass (const char* dllname, const char *procname, int arg) {
    HINSTANCE dllhandle;
    FARPROC proc;
    typedef DllClass* (*ifuncp) (int);
    ifuncp dllfunc;
    int procfound = 1;
    DllClass* dllclass;

    if (! (dllhandle = LoadLibrary(dllname))) {
	printf ("Error loading DLL `%s'\n", dllname);
	return 0;
    }

    if (! (proc = GetProcAddress (dllhandle, procname))) {
        procfound = 0;
    } 

    if (! procfound) {
	char* newname = (char *) malloc (strlen (procname) + 2);
        newname[0] = '_';
	strcpy (newname + 1, procname);
        if (! (proc = GetProcAddress (dllhandle, newname)))
          procfound = 0;
	else
          procfound = 1;
        free (newname);
    }

    if (! procfound) {
	printf ("Can't find proc `%s' (nor `_%s') in DLL `%s'\n", 
                procname, procname, dllname);
	return 0;
    }

    dllfunc = (ifuncp) proc;
    dllclass = (*dllfunc) (arg);

    return dllclass;
}

int main (int argc, char *argv[]) {
    const DllClass *dllclass = new_dllclass ("c++dll.dll", "new_dllclass", 5);
    int retcode = dllclass->virtual_method ();
    retcode = dllclass->non_virtual_method ();
    exit (0);
}

