#ifndef dllclass_h_included
#define dllclass_h_included

#if BUILDING_DLL
# define DLLIMPORT __declspec (dllexport)
#else /* Not BUILDING_DLL */
# define DLLIMPORT __declspec (dllimport)
#endif /* Not BUILDING_DLL */

struct DLLIMPORT 
DllClassBase {
  virtual int virtual_method () const;
};

class DLLIMPORT 
DllClass : public DllClassBase {
public:
  DllClass (int i = 0);
  virtual ~DllClass ();
  int non_virtual_method () const;
  virtual int virtual_method () const;
private:
  int i_;
};

extern "C" {
DLLIMPORT DllClass* new_dllclass (int);
DLLIMPORT void delete_dllclass (DllClass*);
DLLIMPORT int non_virtual_method (const DllClass*);
DLLIMPORT int virtual_method (const DllClass*);
}

#endif /* dllclass_h_included */
